com.lowagie.text.pdf

## Class PdfDestination

- java.lang.Object
- - com.lowagie.text.pdf.PdfObject
  - - com.lowagie.text.pdf.PdfArray
    - - com.lowagie.text.pdf.PdfDestination

-     public class PdfDestination
      extends PdfArray

  A `PdfColor` defines a Color (it's a `PdfArray` containing 3 values).
  See Also:
    `PdfDictionary`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `FIT` This is a possible destination type
    `static int` | `FITB` This is a possible destination type
    `static int` | `FITBH` This is a possible destination type
    `static int` | `FITBV` This is a possible destination type
    `static int` | `FITH` This is a possible destination type
    `static int` | `FITR` This is a possible destination type
    `static int` | `FITV` This is a possible destination type
    `private boolean` | `status` Is the indirect reference to a page already added?
    `static int` | `XYZ` This is a possible destination type

    - ### Fields inherited from class com.lowagie.text.pdf.PdfArray

      `arrayList`

    - ### Fields inherited from class com.lowagie.text.pdf.PdfObject

      `ARRAY, BOOLEAN, bytes, DICTIONARY, INDIRECT, indRef, NAME, NOTHING, NULL, NUMBER, STREAM, STRING, TEXT_PDFDOCENCODING, TEXT_UNICODE, type`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PdfDestination(int type)` Constructs a new `PdfDestination`.
    `PdfDestination(int type, float parameter)` Constructs a new `PdfDestination`.
    `PdfDestination(int type, float left, float top, float zoom)` Constructs a new `PdfDestination`.
    `PdfDestination(int type, float left, float bottom, float right, float top)` Constructs a new `PdfDestination`.
    `PdfDestination(java.lang.String dest)` Creates a PdfDestination based on a String.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addPage(PdfIndirectReference page)` Adds the indirect reference of the destination page.
    `boolean` | `hasPage()` Checks if an indirect reference to a page has been added.

    - ### Methods inherited from class com.lowagie.text.pdf.PdfArray

      `add, add, add, add, addFirst, contains, getArrayList, getAsArray, getAsBoolean, getAsDict, getAsIndirectObject, getAsName, getAsNumber, getAsStream, getAsString, getDirectObject, getPdfObject, isEmpty, listIterator, remove, set, size, toPdf, toString`

    - ### Methods inherited from class com.lowagie.text.pdf.PdfObject

      `canBeInObjStm, getBytes, getIndRef, isArray, isBoolean, isDictionary, isIndirect, isName, isNull, isNumber, isStream, isString, length, setContent, setIndRef, type`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### XYZ

          public static final int XYZ

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FIT

          public static final int FIT

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITH

          public static final int FITH

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITV

          public static final int FITV

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITR

          public static final int FITR

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITB

          public static final int FITB

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITBH

          public static final int FITBH

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### FITBV

          public static final int FITBV

      This is a possible destination type
      See Also:
        Constant Field Values

    - #### status

          private boolean status

      Is the indirect reference to a page already added?

  - ### Constructor Detail

    - #### PdfDestination

          public PdfDestination(int type)

      Constructs a new `PdfDestination`.

      If type equals FITB, the bounding box of a page will fit the window of the Reader. Otherwise the type will be set to FIT so that the entire page will fit to the window.

      Parameters:
        `type` - The destination type

    - #### PdfDestination

          public PdfDestination(int type,
                        float parameter)

      Constructs a new `PdfDestination`.

      If type equals FITBH / FITBV, the width / height of the bounding box of a page will fit the window of the Reader. The parameter will specify the y / x coordinate of the top / left edge of the window. If the type equals FITH or FITV the width / height of the entire page will fit the window and the parameter will specify the y / x coordinate of the top / left edge. In all other cases the type will be set to FITH.

      Parameters:
        `type` - the destination type
        `parameter` - a parameter to combined with the destination type

    - #### PdfDestination

          public PdfDestination(int type,
                        float left,
                        float top,
                        float zoom)

      Constructs a new `PdfDestination`.

      Display the page, with the coordinates (left, top) positioned at the top-left corner of the window and the contents of the page magnified by the factor zoom. A negative value for any of the parameters left or top, or a zoom value of 0 specifies that the current value of that parameter is to be retained unchanged.

      Parameters:
        `type` - must be a PdfDestination.XYZ
        `left` - the left value. Negative to place a null
        `top` - the top value. Negative to place a null
        `zoom` - The zoom factor. A value of 0 keeps the current value

    - #### PdfDestination

          public PdfDestination(int type,
                        float left,
                        float bottom,
                        float right,
                        float top)

      Constructs a new `PdfDestination`.

      Display the page, with its contents magnified just enough to fit the rectangle specified by the coordinates left, bottom, right, and top entirely within the window both horizontally and vertically. If the required horizontal and vertical magnification factors are different, use the smaller of the two, centering the rectangle within the window in the other dimension.

      Parameters:
        `type` - must be PdfDestination.FITR
        `left` - a parameter
        `bottom` - a parameter
        `right` - a parameter
        `top` - a parameter
      Since:
        iText0.38

    - #### PdfDestination

          public PdfDestination(java.lang.String dest)

      Creates a PdfDestination based on a String. Valid Strings are for instance the values returned by SimpleNamedDestination: "Fit", "XYZ 36 806 0",...
      Parameters:
        `dest` - a String notation of a destination.
      Since:
        iText 5.0

  - ### Method Detail

    - #### hasPage

          public boolean hasPage()

      Checks if an indirect reference to a page has been added.
      Returns:
        `true` or `false`

    - #### addPage

          public boolean addPage(PdfIndirectReference page)

      Adds the indirect reference of the destination page.
      Parameters:
        `page` - an indirect reference
      Returns:
        true if the page reference was added